'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo using ftp4w32.dll, a ftp protocol library.
'
PROGRAM	"ftp4wtest"
VERSION	"0.0000"
CONSOLE
'
	IMPORT	"xst"   			' Standard library : required by most programs
	IMPORT	"xsx"
'	IMPORT	"user32"
'	IMPORT	"kernel32"
	IMPORT	"ftp4w32"
'
DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
'
FUNCTION  Entry ()

	version$ = NULL$ (256)
	Ftp4wVer (&version$, LEN (version$))
	version$ = CSIZE$ (version$)
	PRINT "Ftp4w32 version : "; version$

	ret = FtpInit (NULL)
	IF ret != $$FTPERR_OK THEN
		PRINT "FtpInit Error : error ="; ret
		GOTO quit
	END IF

' set synchronous operation
	FtpSetSynchronousMode ()

' connect to a public ftp server which mirrors simtel and sunsite
	server$ = "ftp.nluug.nl"

	ret = FtpOpenConnection (&server$)
	IF ret != $$FTPERR_OK THEN
		PRINT "FtpOpenConnection Error : error ="; ret
		GOTO quit
	END IF

' send user name
	userName$ = "anonymous"
	ret = FtpSendUserName (&userName$)
	IF (ret != $$FTPERR_ENTERPASSWORD) THEN
		IF (ret != $$FTPERR_OK) THEN
			PRINT "FtpSendUserName Error : error ="; ret
			GOTO close
		END IF
	END IF

' send password
	passWord$ = "guest"
	ret = FtpSendPasswd (&passWord)
	IF ret != $$FTPERR_OK THEN
		PRINT "FtpSendPasswd Error : error ="; ret
		GOTO close
	END IF

' get current directory, long version
 	dirFile$ = "ftpdir.txt"
 	ret = FtpDir (NULL, &dirFile$, $$TRUE, 0, 0)
	IF ret != $$FTPERR_OK THEN
		PRINT "FtpDir Error : error ="; ret
	END IF

	XstLoadStringArray (dirFile$, @text$[])
	IFZ text$[] THEN
		PRINT "FtpDir error : text$[] is empty"
	ELSE
		FOR i = 0 TO UBOUND (text$[])
			PRINT text$[i]
		NEXT i
	END IF

' change to new directory
	path$ = "pub/graphics/ImageMagick"
	ret = FtpCWD (&path$)

	IF ret != $$FTPERR_OK THEN
		PRINT "FtpCWD Error : error ="; ret
		GOTO close
	END IF

' get new directory info
 	ret = FtpDir (NULL, &dirFile$, $$TRUE, 0, 0)

	IF ret != $$FTPERR_OK THEN
		PRINT "FtpDir Error : error ="; ret
	END IF

	XstLoadStringArray (dirFile$, @text$[])
	IFZ text$[] THEN
		PRINT "FtpDir error : text$[] is empty"
	ELSE
		PRINT
		FOR i = 0 TO UBOUND (text$[])
			PRINT text$[i]
		NEXT i
	END IF

' download an ASCII text file "README.txt"
	file$ = "README.txt"
	localFile$ = file$
	ret = FtpRecvFile (&file$, &localFile$, $$TYPE_A, 0, 0, 0)

	IF ret != $$FTPERR_OK THEN
		PRINT "FtpRecvFile Error : error ="; ret
	END IF

' display the downloaded file
	XstLoadStringArray (localFile$, @text$[])
	IFZ text$[] THEN
		PRINT "FtpRecvFile error : text$[] is empty"
	ELSE
		PRINT
		PRINT "Downloaded file : "; file$
		FOR i = 0 TO UBOUND (text$[])
			PRINT text$[i]
		NEXT i
	END IF

' change to new directory
	path$ = "/pub/mediaplayer/vlc/vlc/3.0.9.2/win64"
	ret = FtpCWD (&path$)

	IF ret != $$FTPERR_OK THEN
		PRINT "FtpCWD Error : error ="; ret
		GOTO close
	END IF

' download a binary file "vlc-3.0.9.2-win64.7z"
' binary type transfer uses $$TYPE_I cType
' file names are case sensitive
' (file is for VLC media player, old version)
	file$ = "vlc-3.0.9.2-win64.7z"
	localFile$ = file$
	ret = FtpRecvFile (&file$, &localFile$, $$TYPE_I, 0, 0, 0)

	IF ret != $$FTPERR_OK THEN
		PRINT "FtpRecvFile Error : error ="; ret
	ELSE
		PRINT
		PRINT "Downloaded file : "; file$
	END IF

close:
	ret = FtpCloseConnection ()
	IF ret != $$FTPERR_OK THEN
		PRINT "FtpCloseConnection Error : error ="; ret
		FtpLocalClose ()
	END IF

	XstDeleteFile (@dirFile$)


quit:

	FtpRelease ()

	a$ = INLINE$ ("Press any key to quit >")

END FUNCTION
END PROGRAM
